#############MAQC Project data AGL_1_C1 to AGL_3_D5, only sample C and D total 30 microarrays#########################

I <- 10           #the number of replications, as in the paper

#############some understanding about the data sets##########################################
###############################Preprocessing#################################################

temp <- read.table(file="H:\\Research\\Stoery\\norm_MAQC_AGL_cd_all.csv",sep=",",
  row.names=NULL,skip=1)                                                    #import data 
maqc <- data.frame(temp)

a <- maqc[,6]
b <- maqc[,10]
sum(a==b)
length(a)

#The flag vectors for each sample are not exactly the same, we have to combine them all 
flagmat <- matrix(0,ncol=30,nrow=nrow(maqc))
geneid <- maqc[,2]
Intens <- matrix(0,ncol=30,nrow=nrow(maqc))
Ratios <- matrix(0,ncol=30,nrow=nrow(maqc))

for (i in 1:30)
  {
	flagmat[,i] <- (maqc[,4*i+2]=='P')
	Intens[,i] <- logb((maqc[,4*i-1])*(maqc[,4*i+1]),2)
	Ratios[,i] <- logb((maqc[,4*i-1])/(maqc[,4*i+1]),2)
  }

Ratiosdye <- Ratios
Ratiosdye[,16:30] <- (-1)*Ratios[16:30]
flagsum <- apply(flagmat,1,sum)
hist(flagsum) 
flagsub1 <- apply(flagmat[,1:5],1,sum)+apply(flagmat[,11:15],1,sum)+apply(flagmat[,21:25],1,sum)
flagsub2 <- apply(flagmat[,6:10],1,sum)+apply(flagmat[,16:20],1,sum)+apply(flagmat[,26:30],1,sum)
hist(flagsub1)
hist(flagsub2)

flag1 <- (flagsum>15)
flag2 <- (flagsub1>10)
flag3 <- (flagsub2>10)
flag <- flag1+flag2+flag3

sum(flag==0)            
sum(flag1==0)

ID <- geneid[flag==0]
Intenssub <- Intens[flag==0,]
Ratiossub <- Ratiosdye[flag==0,]        #after filtering, 21767 genes are left


################################################################
######### Find the number and location of repetitions ##########
################################################################

tmp1 <- as.vector(ID)
tmp2 <- as.factor(tmp1)
tmp3 <- levels(tmp2)
count <- rep(0,length=length(tmp3))
for(i in 1:length(tmp3))
   {
	  tmp <- (tmp1==tmp3[i])
	  count[i] <- sum(tmp)
	}

tmp4 <- tmp3[count==I]
subset <- NULL
for(i in 1:length(tmp4))
   {
	subset <- c(subset,(1:length(ID))[ID==tmp4[i]])
     }

ratiosmat <- Ratiossub[subset,]
ratiosmatrix <- ratiosmat[,c(-6,-14)]



##########################Validation Test###################################
SD <- SDinarray(ratiosmatrix,I)
SDreml <- SDreml(ratiosmatrix,I)

pmatrix <- NULL
pmatrix2 <- NULL

for (i in 1:ncol(ratiosmatrix))
  {
	pmatrix <- rbind(pmatrix,validation(ratiosmatrix[,i],SD,I))
	pmatrix2 <- rbind(pmatrix2,validation(ratiosmatrix[,i],SDreml,I))

  }
  
########################################The END#######################################################################