nslide<-2                       #the number of arrays
thresh<-2                       #thresholding for filtering.

#########################################Load the data and Preprocessing#######################################################
hp<-read.table(file="H:\\Research\\Customized Array\\proj\\finaldata.csv",sep=",",
  row.names=NULL,skip=1)        #import data 

Block<-hp[,1]                   #Block, Column, Row, flag03 and flag04 are all numeric, the rest are factors. Basic info
Column<-hp[,2]                  
Row<-hp[,3]
ID<-hp[,4]

flag03<-hp[,9]
flag04<-hp[,10]
tmp1<-hp[,c(5,7)]
tmp2<-hp[,c(6,8)]

ID<-as.character(ID)

flag<-flag03+flag04
ID1<-ID[flag==0]
Block1<-Block[flag==0]
Column1<-Column[flag==0]
Row1<-Row[flag==0]
tmp1<-tmp1[flag==0,]
tmp2<-tmp2[flag==0,]
dim(tmp1)                       #First step: remove the genes that have "flag" other than 0 on both arrays

Intens<-matrix(0,nrow=nrow(tmp1),ncol=ncol(tmp1))
Ratios<-matrix(0,nrow=nrow(tmp1),ncol=ncol(tmp1))

for (j in 1:ncol(tmp1))
  {
	a<-as.character(tmp1[,j])
	b<-as.character(tmp2[,j])
      a2<-as.numeric(a)
      b2<-as.numeric(b)
      Intens[,j]<-a2
      Ratios[,j]<-b2
   }

hist(Intens[,1])
hist(Intens[,2])

for (i in 1:nslide)
  {
	tmp<-Intens[,i]
	tmp[tmp<7]<-NA
	Intens[,i]<-tmp
  }
Flag<-(Intens[,1]=="NA")+(Intens[,2]=="NA")
length(Flag)                                  

Intens<-Intens[Flag==0,]
Ratios<-Ratios[Flag==0,]
ID2<-ID1[Flag==0]
Block2<-Block1[Flag==0]
Column2<-Column1[Flag==0]
Row2<-Row1[Flag==0]

#dim(Intens)                          #Second step: remove the genes that have low intensity

IntenMed  <- apply(Intens,2,median)   #slide median intensity
IntenMed  <- median(Intens)/IntenMed
Intens <- t(t(Intens)*IntenMed)       #normalized intensities

########################## Quality filtering: Output Geneset##############################
IntenAve<-apply(Intens,1,mean)
IntenSD <-apply((Intens-IntenAve)^2,1,sum)
IntenSD <-sqrt(IntenSD/(nslide-1))
CoefVar <-IntenSD/IntenAve

tmp1<-median(CoefVar)
tmp2<-(quantile(CoefVar,0.75)-quantile(CoefVar,0.25))/1.35    #robust SD

Geneset<-(1:length(ID2))[CoefVar<tmp1+thresh*tmp2]
length(Geneset)
length(Geneset)/nrow(Intens)

tmp3 <- rep(F, nrow(Intens))
tmp3[Geneset] <- T
Geneset <- tmp3
length(Geneset)
length(ID2)
sum(Geneset)

Intens<-Intens[Geneset,]
Ratios<-Ratios[Geneset,]
ID3<-ID2[Geneset]
Block3<-Block2[Geneset]
Column3<-Column2[flag==0]
Row3<-Row2[flag==0]


count<-rep(0,length(ID3))
for (j in 1:length(ID3)) 
  {
	tmp<-(ID3==ID3[j])
	count[j]<-sum(tmp)
  }
sum(count==3)

flag<-(count==3)
intens<-Intens[flag,]
ratios<-Ratios[flag,]
Blk.sub<-Block3[flag]
Col.sub<-Column3[flag]
Row.sub<-Row3[flag]
ID.sub<-ID3[flag]
print(dim(ratios))

###############################################Preprocessing End######################################################

################################Find the replications#################################################################

blksign<-rep(0,16)
for (jj in 1:16)                     #the distribution of each block
  {
	tmp<-(Blk.sub==jj)
	blksign[jj]<-sum(tmp)
  }

aa<-dim(ratios)
aa<-aa[1]/3
croset<-NULL                         #generate a random sample for validation test, due to the sample itself, you may get different test statistics
for (i in 1:10)                      #values, but the conclusion should be similar, according to our experiments.
  {     		
 	 if (i==10) tmp<- sample(c((ceiling(aa/10)*9+1):aa),5)
 	 else {tmp<-sample(c((ceiling(aa/10)*(i-1)+1):(ceiling(aa/10)*i)),5)}
 	 croset<-c(croset,tmp)
  }
croset<-sort(c(croset*3-2,croset*3-1,croset*3))  

   
################################################NORMALIZATION##########################################################
######data set: intens, ratios; first do the within array normalization SLIM without the block effect##################
######Considering the design of this data set, the block effect is not identifiable here###############################

Ratioa<-matrix(0,nrow=nrow(ratios),ncol=nslide)      #normalized data
norm.res  <- NULL     #output
Ratiod<-matrix(0,nrow=nrow(ratios),ncol=nslide)   #intensity effect

for(ii in 1:nslide)
  {
###############Processing###################################	
	 
	Inten<-intens[,ii]
	Ratio<-ratios[,ii]
	number<-ii
	inten<-Inten[-croset]
	ratio<-Ratio[-croset]
	#length(inten)
	ratio<-ratio-median(Ratio)                  #Global normalization
	n<-length(ratio)/3


######################Normalization##########################
	exp.level<-rep(0,length(ratio))           #fitted beta

	index<-seq(1,length(ratio),by=3)
	tmp<-cbind(ratio[index],ratio[index+1],ratio[index+2])
	beta<-apply(tmp,1,mean)   #gene effect
	exp.level[index]   <- beta;
	exp.level[index+1] <- beta;
	exp.level[index+2] <-beta;
	presid<-ratio-exp.level            #partial residuals; substract gene effect

	i <- 0; error <- 100;

 	while(error > 0.0001 && i < 21)            #loops at most 20 times
    	  { 
		fitted <- lowess(inten, presid, f=0.2)     #intensity effect
      	Sfval  <- approx(fitted, xout=inten)$y      #smoothing fit-value
      	Sfval  <- Sfval - mean(Sfval)
      	presid <- ratio - Sfval
                                 #Partial residuals, no block effect
      
      	beta <- (presid[index]+presid[index+1]+presid[index+2])/3  #given intensity effect, estimate RNA effect
      	error <- mean((beta - exp.level[index])^2); i <- i+1         #gene effect error
      	exp.level[index]   <- beta;
      	exp.level[index+1] <- beta;
      	exp.level[index+2] <- beta;
      	presid <- ratio - exp.level  
      	print(c(i,error))
        }
############## end of fitting the PLS  ########################

##### Normalized expression ratio #############################
	Ratioa[,ii] <- Ratio-median(Ratio) - approx(fitted, xout=Inten,rule=3)$y
                                                 #substract the intensity effect.
         
	Ratiod[,ii]<-approx(fitted, xout=Inten,rule=3)$y

  }


################################LOWESS Normalization####################################

Ratiolow<-ratios

for (i in 1:nslide)
{
	Ratiolow[,i]<-lownorm(intens[,i],ratios[,i],croset)
}


###############################Validation Test##########################################

pmatrix<-matrix(0,nrow=4*nslide,ncol=3)

for (i in 1:nslide) 
  {  
	sd1<-SDebays(Ratioa[,i],intens[,i],Ratioa,croset)
      pmatrix[(4*i-3),1]<-validation(ratios[,i],sd1,croset)[[1]]      #Global
      pmatrix[(4*i-3),2]<-validation(Ratiolow[,i],sd1,croset)[[1]]    #LOWESS
      pmatrix[(4*i-3),3]<-validation(Ratioa[,i],sd1,croset)[[1]]      #SLIM
      
      pmatrix[(4*i-2),1]<-validation(ratios[,i],sd1,croset)[[2]]
      pmatrix[(4*i-2),2]<-validation(Ratiolow[,i],sd1,croset)[[2]]
      pmatrix[(4*i-2),3]<-validation(Ratioa[,i],sd1,croset)[[2]]

      pmatrix[(4*i-1),1]<-validation(ratios[,i],sd1,croset)[[3]]
      pmatrix[(4*i-1),2]<-validation(Ratiolow[,i],sd1,croset)[[3]]
      pmatrix[(4*i-1),3]<-validation(Ratioa[,i],sd1,croset)[[3]]
       

      pmatrix[(4*i),1]<-validation(ratios[,i],sd1,croset)[[4]]
      pmatrix[(4*i),2]<-validation(Ratiolow[,i],sd1,croset)[[4]]
      pmatrix[(4*i),3]<-validation(Ratioa[,i],sd1,croset)[[4]]
      
  }


########################################The END###################################################################
