########################LOWESS Normalization##########################
lownorm<-function(Inten, Ratio, crossset)
{ 
			
	inten<-Inten[-crossset]
	ratio<-Ratio[-crossset]
	
	ratio<-ratio-median(ratio)                 #Global normalization
	Ratio<-Ratio-median(Ratio)
		
	fitted<-lowess(inten,ratio,f=0.4)
	Ratio<-Ratio-approx(fitted,xout=Inten,rule=3)$y	
	
	return(Ratio)
	
}
	


######################Empirical Baysian estimation of SD##############

SDebays<-function(ratio,inten,ratioaa,croset)              
  { 
      ratio<-as.vector(ratio)
      inten<-as.vector(inten)
	Ratio<-ratio[croset]	
	
	nn<-length(Ratio)/3
	
	index<-seq(1,length(ratio),by=3)
	tmp1<-ratio[index]
	tmp2<-ratio[index+1]
	tmp3<-ratio[index+2]
      tmp<-cbind(tmp1,tmp2,tmp3)
	mean<-apply(tmp,1,mean)
      sumtmp<-apply((tmp-mean)^2,1,sum)/2                        #sample mean of the 3 replications within each array        
    
      intentmp<-matrix(inten,nrow=3,ncol=length(inten)/3)        #smooth the squared residual on the mean of the intensity
      intenmean<-apply(intentmp,2,mean)
      fitted3<-lowess(intenmean,sumtmp,f=0.1)                    #tuning bandwidth  
    
   
      inten.sub<-inten[croset]
      temp<-matrix(inten.sub,nrow=3,ncol=50)
      inten.sub<-apply(temp,2,mean)
      sdsmooth <- approx(fitted3, xout=inten.sub)$y              #Smoothing estimator
   
      SDs<-SDreml(ratioaa)
	sdagg<-SDs[croset]
	
	
      index<-seq(1,length(croset),by=3)
      sdagg<-sdagg[index]
      mu<-8/9                                        
      sdfinal<-mu*sdsmooth+(1-mu)*sdagg               #empirical Bayesian estimator
	return(sdfinal)
	                                                #return the one third length of ratio[croset]
  }


#########################Validation Test##################################

validation<-function(Ratio,SDs,crossset)        #the length of ratio SDs is 50; Ratios has the whole length 1716=572*3
  {     
	
	Ratio<-as.vector(Ratio)
	ratio<-Ratio[crossset]
	n<-length(ratio)/3
	
	index<-seq(1,length(ratio),by=3)
	tmp1<-ratio[index]
	tmp2<-ratio[index+1]
	tmp3<-ratio[index+2]
	tmp<-cbind(tmp1,tmp2,tmp3)
	mean<-apply(tmp,1,mean)
	
	test<-apply((tmp-mean)^2,1,sum)

	test11<-sum(test)
	test1 <-sum(test/SDs)            #test statistics T1
      p1<-1-pchisq(test1,df=n*2)       #pvalue for test statistics T1
	
      tmp4<-sum((abs(tmp1-mean)+abs(tmp2-mean)+abs(tmp3-mean))/sqrt(2/3)/(SDs[index]))
	test2<-sqrt(n)*(tmp4/n-3*sqrt(2/3.14))/1.579           #test statistics T2
	p2<-1-pnorm(test2)

	test3<-(sum(test)-2*sum(SDs))/sqrt(4*sum(SDs^2))       #test statistics T3
	p4<-1-pnorm(test3)
	
	test4<-(sum(abs(tmp1-mean)+abs(tmp2-mean)+abs(tmp3-mean))- sqrt(12/pi)*sum(sqrt(SDs)))/sqrt(1.0525*sum(SDs))
      p4<-1-pnorm(test4)                                                  #test statistics T4
     
      return(p1,p2,p3,p4)

	rm(tmp1,tmp2,tmp3,tmp,tmp4,test22,test11)

  }

