
###############################LOWESS Normalization###############################################
lownorm<-function(Inten, Ratio, Block,crossset)
  { 
	noblk<-BLKno
		
	inten<-Inten[-crossset]
	ratio<-Ratio[-crossset]
	block<-Block[-crossset]
	cot<-rep(0,48)
	ratio<-ratio-median(ratio)
	Ratio<-Ratio-median(Ratio)
	xgrid<-c(5,13)
	#print(xgrid)
	xgrid<-seq(xgrid[1],xgrid[2],length=200)
	
	fitratio<-NULL
	
      for (i in 1:noblk)
	  {  	  
            tmp<-as.character(i)
		cot[i]<-sum(block==tmp)  
	  }
	smallset<-(1:48)[cot==1]                              #the gene set that only one gene resides in the block
	smallerset<-c(2,7,23,39)
	                                                      #remove these genes in the following LOWESS fitting
	for (i in 1:noblk) 
		
	  {   
	    if (!is.element(i,smallset))
	      {
		   tmp<-as.character(i)
		   inten.sub<-inten[block==tmp]
		   print(c(i,range(inten.sub)))
		
		   ratio.sub<-ratio[block==tmp]
		   fitted<-lowess(inten.sub,ratio.sub, f=0.4)
		   Ratio[Block==tmp]<-Ratio[Block==tmp]-approx(fitted,xout=Inten[Block==tmp],rule=3)$y
	
		   if (!is.element(i,smallerset))
	           {
		       fitratio<-rbind(fitratio,approx(fitted,xout=xgrid,rule=3)$y)
                 }
		}
	   }
	 
	return(Ratio,apply(fitratio,2,mean),sqrt(apply(fitratio,2,var)))
	
  }



###################################REML estimator of SD, equation (14) in the paper######################

SDreml<-function(ratios)              
  { 
  	n<-nrow(ratios)/3
   	sumsq<-matrix(0,nrow=n,ncol=ncol(ratios))
   	withinmean <- matrix(0,nrow=n,ncol=ncol(ratios))

   	for (i in 1:(ncol(ratios)))  
	  {
		ratio<-ratios[,i]
	
		tmp1<-ratio[1:n]
		tmp2<-ratio[(n+1):(2*n)]
		tmp3<-ratio[(2*n+1):(3*n)]
		tmp<-cbind(tmp1,tmp2,tmp3)
    		mean<-apply(tmp,1,mean)
    		withinmean[,i] <- mean
    		sumsq[,i]<-apply((tmp-mean)^2,1,sum)

	  }
	tmp<-apply(sumsq,1,sum)       
	SDs<-tmp/2/nslide                                        #within-array estimate of the variance, s_{W,g}^2

   	allmean <- apply(withinmean,1,mean)
      SDbt <- apply((withinmean-allmean)^2,1,sum)*3/(2-1)        #between-array estimate of variance, s_{B,g}^2
   
      theta <- log(sum(SDbt)/sum(SDs))
   	rho <- (exp(theta)-1)/(exp(theta)+3-1)                     #estimated correlation
   	print(paste("rho",rho))
   	sdreml <- ((nslide-1)*SDbt/(1+(3-1)*rho)+nslide*(3-1)*SDs/(1-rho))/(3*nslide-1)   #REML estimate of variance

   	tmp <- sqrt(sdreml)

	return(c(tmp,tmp,tmp	))                        #return the same length as ratios
}

######################################Validation Test###########################################################

validation<-function(Ratio,SDs,crossset)        #the length of ratio SDs and crosset should be the same
  {     
	Ratio<-as.vector(Ratio)
	ratio<-Ratio[crossset]
	sd<-SDs[crossset]
	n<-length(ratio)/3
	
	tmp1<-ratio[1:n]
	tmp2<-ratio[(n+1):(2*n)]
	tmp3<-ratio[(2*n+1):(3*n)]
	tmp<-cbind(tmp1,tmp2,tmp3)
	mean<-apply(tmp,1,mean)
	SD<-sd[1:n]
	SD<-(SD)^2	

	test<-apply((tmp-mean)^2,1,sum)
	 	
	test3<-(sum(test)-2*sum(SD))/sqrt(4*sum(SD^2))     #test statistics T3
	p4<-1-pnorm(test3)
	
	  
      test3<- (sum(abs(tmp1-mean)+abs(tmp2-mean)+abs(tmp3-mean))- sqrt(12/pi)*sum(sd[1:n]))/sqrt(1.0525*sum(SD))
      p4<-1-pnorm(test4)                                                #test statistics T4

       
      return(round(test3,4),p3,round(test4,4),p4)

	rm(tmp1,tmp2,tmp3,tmp,tmp4,test22,p1,test1,test11)

  }



